  MODULE MONST
  SECTION S.GLOB

* Maschinenmonitor / Debugger
*
* by:  Matthias Meyer
*      Rosenwinkel 36
*      2380 Schleswig


CR      EQU $0D


M:
START:
 NOP

 MOVE.L 4(SP),A0   * Programm anmelden (RAM-Bereich schtzen)
 MOVE.L 12(A0),D0
 ADD.L 20(A0),D0
 ADD.L 28(A0),D0
 ADD.L #2080+$100,D0
 MOVE.L D0,-(SP)   * Lnge des Programmbereichs
 PEA (A0)
 CLR.W -(SP)
 MOVE.W #$4A,-(SP) * SETBLOCK
 TRAP #1
 ADD.W #12,SP

 CLR.L -(SP)       * Supervisormode ein
 MOVE.W #$20,-(SP)
 TRAP #1           * a7' nach d0, a7 nach a7'
 ADDQ.L #6,SP
 LEA USERSTP,A0
 MOVE.L SP,(A0)+
 MOVE.L SP,USP
 MOVE.L D0,(A0)
 MOVE.L D0,SP

 JSR SCRCLR      * Bildschirm lschen, VRAM init.
 MOVEQ #'v',D0   * berlauf ein
 JSR ESCOUT
 LEA STMELD,A0   * Startmeldung
 JSR STROUT
 LEA START,A1
 MOVE.L A1,D0
 JSR ADRHEX
 JSR STROUT
 LEA VRAM+2080,A0
 MOVE.L A0,D0
 JSR ADRHEX      * Prog.ende
 JSR CARRET

 JSR EXCVSET     * Exceptions auffangen

 MOVEQ #14,D0 * 8+7 -1
 LEA REGIST,A0
REGCLR:
 CLR.L (A0)+     * Registerspeicher lschen
 DBF D0,REGCLR
 CLR.W (A0)+     * PSTATUS
 LEA START,A1
 MOVE.L A1,(A0)  * PC auf Neustart


MAINLOOP:
 MOVE.W #$2300,SR
 JSR CARRET      * Eingabeschleife
 JSR PUNKT
NOPNTINP:
 JSR INPLINE     * Eing. abwarten
MUEBERLES:
 JSR READCHAR    * erstes Zeichen der Zeile nach D0
 BEQ.S MAINLOOP  * Leerzeile
 CMP.B #$20,D0
 BEQ.S MUEBERLES
 CMP.B #'.',D0
 BEQ.S MUEBERLES
 JSR KLEINERBU   * Grobuchstaben in kleine umwandeln
 LEA CMDBYTES,A0
 CLR.W D1
CMDSUCH:
 MOVE.B (A0)+,D2
 BEQ.S ERRO      * kein erkennbarer Befehl
 CMP.B D2,D0
 BEQ.S CMDFND
 ADD.W #1,D1
 BRA.S CMDSUCH
CMDFND:
 LEA CMDADRESS,A0
 LEA START,A1
 LSL.W #1,D1         * d1 mal zwei
 ADD.W 0(A0,D1.W),A1 * Adressdistanz zum Start holen
* und Startadr. des Prog. dazuaddieren
 JSR (A1)            * Befehl ausfhren
 BRA.S MAINLOOP      * und nchste Eingabe holen

*

ERRO:
 MOVE.L SUPVSTP,SP * Stackpointer nach Fehler init.
 JSR EINGPOS
 MOVEQ #'?',D0
 JSR PRINT
 BRA.S MAINLOOP




FRSTFLAG:
 DC.W 0   * wenn 0: Programm wird mit KEEP PROCESS verlassen
* sonst einfacher TERM

PRINTNR:
 DC.W 0       * 0-nur Screen, 1-Centronics, 2- RS 232

ZWA: DC.L 0   * Zwischenspeicher

CHGVECTS:
* aufzufangende Exceptions
 DC.B 2,3,4,5,6,7,8,9,32,0,0,0,0,0,0


STMELD:
 DC.B ' *** Happy-Computer - 68000er   ***',13,10
 DC.B ' *** MonST v1.0 by M.Meyer 3/86 ***',CR,CR,'  $',0,' - $',0


* Befehlskrzel

CMDBYTES:
 DC.B '>rmkdg'
 DC.B ';:,',$27 * >'<
 DC.B 'vow=ft'
 DC.B '#$%?'
 DC.B 'ls@'
 DC.B 'zx'
 DC.B 0

 DC.W 0,0  * Platz fr Erweiterungen durch den Anwender

* Adredistanzen zum ProgrammSTART

CMDADRESS:
 DC.W OUTSET-M,REGISTS-M,MEMORY-M,KONTROLL-M,DISASSEM-M,GOPRG-M

 DC.W REGMOD-M,MEMMOD-M,DISASSMOD-M,KONTMOD-M

 DC.W VECTORS-M,OCCUPY-M,WRITEMEM-M,COMPARE-M,FINDBYTES-M,TRACER-M

 DC.W DEZUM-M,HEXUM-M,BINUM-M,RECHNUNG-M

 DC.W FLOAD-M,FSAVE-M,DIRECT-M

 DC.W DISKMON-M,EXIT-M

 DC.W 0,0,0



* Es folgen die einzelnen Befehlsfunktionen


OUTSET:
 JSR MUSTREAD  * Ausgabeeinheit setzen
 CMP.B #'0',D0 * 0...2
 BCS ERRO
 CMP.B #'3',D0
 BCC ERRO
 SUB.B #'0',D0
 LEA PRINTNR,A0
 MOVE.W D0,(A0)
 RTS


REGISTS:
 JSR CARRET
REGISTOUT:
 LEA REGINFO,A0  * zwischengespeicherte Prozessorregister
 JSR STROUT      * ausgeben
 JSR LINEOUT     * CR + evtl. Drucker
 JSR PUNKT
 MOVEQ #';',D0
 JSR PRINT
 JSR ONESPACE
 JSR SPACES
 MOVE.L PCOUNTER,D0
 JSR LONGHEX
 JSR SPACES
 MOVE.W PSTAT,D1 * Statuswort binr ausg.
 MOVE.W D1,D0
 LSR.W #8,D0
 JSR BYTEBIN
 JSR ONESPACE
 MOVE.B D1,D0
 JSR BYTEBIN
 JSR LINEOUT
 JSR STROUT
 JSR LINEOUT
 LEA REGIST,A0
 MOVEQ #'0',D1
REG_LP:
 JSR PUNKT
 MOVEQ #';',D0
 JSR PRINT
 MOVE.B D1,D0
 JSR PRINT
 BSR.S SPACES
 MOVE.L (A0),D0   * Datenregister
 JSR LONGHEX
 CMP.B #'7',D1
 BEQ.S REXIT
 BSR.S SPACES
 MOVE.L 32(A0),D0 * Adrereg.
 JSR LONGHEX
 ADDQ.L #4,A0
 JSR LINEOUT
 ADDQ.B #1,D1
 BRA.S REG_LP
REXIT:
 JSR LINEOUT
 LEA USRR,A0
 JSR STROUT
 MOVE.L USERSTP,D0
 JSR LONGHEX
 JSR LINEOUT
 JSR STROUT
 MOVE.L SUPVSTP,D0
 JSR LONGHEX
 JMP PRINTLINE

SPACES:
 MOVE.L D0,-(SP)
 JSR FOURSPACES
 MOVE.L (SP)+,D0
 RTS

REGINFO:
 DC.B '       PC:         T S  III    XNZVC',0
 DC.B '       data:       adress:',0
USRR:
 DC.B '.;USP  ',0,'.;SSP  ',0
 DC.W 0

*

MEMORY:
 LEA MEMOUT,A3    * Hexdump
 MOVEQ #16,D3  * 16 Bytes pro Zeile
 BRA.S MEMDUMP

KONTROLL:
 LEA KONTROUT,A3  * Textkontrolle
 MOVEQ #64,D3
 BRA.S MEMDUMP

DISASSEM:
 LEA DISASS,A3    * Disassembler
 CLR.L D3

MEMDUMP:
 JSR READADR
 LEA $01000000,A1 * Default
 MOVE.L D0,A0
 JSR READCHAR
 BNE.S MZWAD
MEINZEL:
 JSR CARRET
 JSR (A3)
 JSR PRINTLINE
 ADD.L D3,A0
 JSR CONIN
 CMP.B #$1B,D0
 BEQ.S MEMEX
 CMP.B #32,D0
 BEQ.S MEINZEL
MEMSHLP:
 JSR CARRET
 JSR (A3)
 JSR PRINTLINE
 ADD.L D3,A0
 JSR STOPTEST
 BEQ.S MEMEX
 CMP.B #32,D0
 BEQ.S MHALT
MWEIT:
 CMP.L A1,A0 * a0 => a1 ?
 BCS.S MEMSHLP
MEMEX:
 RTS
MZWAD:
 JSR READADR
 MOVE.L D0,A1
 BRA.S MEMSHLP
MHALT:
 JSR CONIN
 CMP.B #$1B,D0
 BEQ.S MEMEX
 CMP.B #32,D0
 BEQ.S MEINZEL
 BRA.S MWEIT


MEMOUT:
 MOVEM.L D0-D1/A0,-(SP) * Ausgabe von 16 Speicherzellen hex. & ascii ab A0
 JSR ZEILANF
 JSR RESTZLSH
 JSR PUNKT
 MOVEQ #':',D0
 JSR PRINT
 MOVE.L A0,D0
 CMP.L #$FF8000,D0 * I/O Bereich?
 BCC.S IOMEM * ja
 JSR ADRHEX
 JSR SPACES
 MOVEQ #15,D1 * 16 Bytes
MEMOLP:
 CMP.L #$FF8000,A0 * I/O Bereich?
 BCC.S MEMXT * ja
 MOVE.B (A0)+,D0
 JSR BYTEHEX
 JSR ONESPACE
 DBF D1,MEMOLP
 JSR TWOSPACE
 SUB.L #16,A0
 MOVEQ #15,D1
MEMASC:
 MOVE.B (A0)+,D0
 JSR NCPRINT
 DBF D1,MEMASC
MEMXT:
 MOVEM.L (SP)+,D0-D1/A0
 RTS
IOMEM:
 BCLR #0,D0
 MOVE.L D0,A0
 JSR ADRHEX
 JSR SPACES
 MOVEQ #7,D1 * 8 WORDS
IOMLP:
 MOVE.W (A0)+,D0
 JSR WORDHEX
 MOVEQ #32,D0
 JSR PRINT
 JSR PRINT
 DBF D1,IOMLP
 BRA.S MEMXT

KONTROUT:
 MOVEM.L D0-D1/A0,-(SP) * Textauszug (64 Bytes) ab a0
 JSR ZEILANF
 JSR RESTZLSH
 JSR PUNKT
 MOVEQ #$27,D0 * '
 JSR PRINT
 MOVE.L A0,D0
 JSR ADRHEX
 JSR SPACES
 MOVEQ #63,D1
KTROLP:
 MOVE.B (A0)+,D0
 JSR NCPRINT
 DBF D1,KTROLP
 MOVEM.L (SP)+,D0-D1/A0
 RTS

*

GOPRG:
 JSR READPC

GOPC:
 MOVE.L SUPVSTP,SP   * Programm starten
 MOVE.L USERSTP,A0 * Stackpointer init.
 MOVE A0,USP
 LEA REGIST,A6 * D0-D7/A0-A6 aus Puffer holen
 MOVE.L 56(A6),-(SP)
 MOVEM.L (A6),D0-D7/A0-A5 
 MOVE.L (SP)+,A6
 MOVE.L PCOUNTER,-(SP)
 MOVE.W PSTAT,-(SP)
 RTE * alter Trick


* Einsprung von EXCEPTION-Vektoren

BREAK:
 JSR SAVEREGS
 BSR.S GETPC * oberstes Byte des PC enthlt Vektornummer (raffiniert!)
 BRA.S EL100
GETPC:
 MOVE.L (SP)+,D0
 MOVE.L D0,D1
 AND.L #$00FFFFFE,D1 * oberstes Byte des PC wieder lschen (kosmetisch)
 MOVE.L D1,-(SP)
 RTS
EL100:
 ROL.L #8,D0
 AND.W #$00FF,D0
 MOVE.W D0,D5  * Vektornummer

 CMP.W #4,D5
 BCC.S EXCNRM     * Exc. Gruppe Null
 MOVE.W (SP)+,D2 * Zusatzwort
 MOVE.L (SP)+,D3 * Zugriffsadr.
 MOVE.W (SP)+,D4 * Befehlsreg.
EXCNRM:
 JSR SAVECREGS

CLRTSTPUF:
 MOVE.W #$0B,-(SP) * Tastaturpuffer lschen
 TRAP #1 * CONSTAT
 ADDQ.L #2,SP
 TST.W D0
 BEQ.S TSTLEER
 JSR CONIN
 BRA.S CLRTSTPUF
TSTLEER:
 CLR.L D1         * Cu. nach unten
 MOVEQ #24,D2
 JSR RCRSET
 MOVEQ #'!',D0
 JSR PRINT
 JSR CRSLEFT      * blinkendes Ausrufezeichen
 JSR CRSON

 MOVE.W #$2300,SR * Interrupts fr Tastaturbehandlung freigeben!
 JSR CONIN        * auf Tastendruck warten wegen Bildschirminhalt

 MOVE.W D0,D7

 LEA EXCMELD,A0
 JSR STROUT
 MOVE.W D5,D0
 EXT.L D0
 JSR DEZOUT
 JSR STROUT
 JSR BYTEHEX
 JSR STROUT
 LSL.W #2,D0
 JSR WORDHEX

 CMP.W #4,D5
 BCC.S EGRP12
 JSR STROUT
 MOVE.W D2,D0
 JSR BYTEBIN    * Zusatzwort binr
 JSR SPACES
 MOVE.L D3,D0
 JSR LONGHEX
 JSR SPACES
 MOVE.W D4,D0
 JSR WORDHEX
EGRP12:
 CMP.W #$1B,D7  * ESC
 BEQ MAINLOOP
 JSR REGISTS
 JMP MAINLOOP


SAVEREGS:
 MOVE.L A6,-(SP) * D0-D7/A0-A6 retten
 LEA REGIST,A6
 MOVEM.L D0-D7/A0-A5,(A6)
 MOVE.L (SP)+,56(A6)
 RTS

SAVECREGS:
 MOVE.L (SP)+,D0
 LEA PSTAT,A1
 MOVE.W (SP)+,(A1)+  * STATUS
 MOVE.L (SP)+,(A1)+  * PC
 MOVE USP,A2
 MOVE.L A2,(A1)+ * USP
 MOVE.L SP,(A1)  * SSP
 MOVE.L D0,-(SP)
 RTS

SAVREG:
 BSR.S SAVEREGS  * smtliche Reg. retten
 BRA.S SAVECREGS


EXCMELD:
 DC.B '! exception no. ',0,'  (=$',0,')  adr. $',0
 DC.B CR,'additional  access      command',CR,0
 DC.W 0

READPC:
 JSR READCHAR
 BEQ.S RPNOADR
 JSR READBACK
 JSR READADR
 BTST #0,D0
 BNE ERRO
 LEA PCOUNTER,A0
 MOVE.L D0,(A0)
RPNOADR:
 RTS


EXCVSET:
 LEA CHGVECTS,A0  * Setzen der Exceptionvektoren
 LEA BREAK,A1    * auf BREAK-Entry richten 
EXVLP:
 CLR.L D0
 MOVE.B (A0)+,D0
 BEQ ILL
 MOVE.L D0,D1
 LSL.L #2,D0
 ROR.L #8,D1
 MOVE.L D0,A2
 MOVE.L A1,D2
 AND.L #$00FFFFFF,D2
 OR.L D1,D2
 MOVE.L D2,(A2)
 BRA.S EXVLP 



VECTORS:
 JSR CARRET * Exc.vektoren ausg.
 LEA BREAK,A1
 MOVEQ #8,D1
VECTLP:
 JSR ONESPACE
 MOVEQ #':',D0
 JSR PRINT
 MOVE.L D1,D0
 JSR ADRHEX
 MOVEQ #16,D0
 JSR SPACETAB
 MOVE.L D1,A0
 MOVE.L (A0),D0
 MOVE.L D0,D2
 AND.L #$FFFFFF,D2
 ROL.L #8,D0
 JSR BYTEHEX
 JSR TWOSPACE
 MOVE.L D2,D0
 JSR ADRHEX
 MOVEQ #32,D0
 CMP.L A1,D2
 BNE.S VCNOB
 MOVEQ #'*',D0
VCNOB:
 JSR PRINT
 JSR SPACES
 JSR DOPPELKR
 MOVE.L D1,D0
 LSR.L #2,D0
 JSR DEZOUT
 JSR LINEOUT
 JSR STOPTEST
 BEQ CRSUP
 ADDQ.L #4,D1
 CMP.W #$400,D1
 BNE.S VECTLP
 JMP CRSUP

*

REGMOD:
 JSR READCHAR * Reg. ndern
 BEQ ERRO
 CMP.B #32,D0
 BEQ.S PCMOD
 JSR KLEINERBU
 CMP.B #'u',D0
 BEQ.S USPMOD
 CMP.B #'s',D0
 BEQ.S SSPMOD
 CMP.B #'0',D0
 BCS ERRO
 CMP.B #'8',D0
 BCC ERRO
 SUB.B #'0',D0
 MOVE.W D0,D2
 LSL.W #2,D0
 LEA REGIST,A0
 ADD.W D0,A0
 JSR READLONG
 MOVE.L D0,(A0)
 CMP.B #7,D2
 BEQ.S RMXT
 JSR READLONG
 MOVE.L D0,32(A0)
RMXT:
 RTS
PCMOD:
 JSR READLONG
 BTST #0,D0
 BNE ERRO * ungerade
 LEA PCOUNTER,A0
 MOVE.L D0,(A0)
 SUB.L #2,A0
 JSR READBINBYT  * hi-Byte Statusreg.
 AND.B #%10100111,D0
 MOVE.B D0,(A0)+
 JSR READBINBYT
 AND.B #%00011111,D0
 MOVE.B D0,(A0)
 RTS
USPMOD:
 LEA USERSTP,A0
 BRA.S STPMOD
SSPMOD:
 LEA SUPVSTP,A0
STPMOD:
 JSR MUSTREAD * "SP" berlesen
 JSR MUSTREAD
 JSR READLONG
 BTST #0,D0
 BNE ERRO * ungerade
 MOVE.L D0,(A0)
 RTS


MEMMOD:
 JSR READADR * Hexdump ndern
 MOVE.L D0,A0
 MOVE.L D0,A1
 MOVEQ #15,D1
MMODLP:
 JSR READBYTE
 MOVE.B D0,(A0)+
 DBF D1,MMODLP
* Hexdump neu ausgeben
 MOVE.L A1,A0
 JMP MEMOUT

KONTMOD:
 JSR READADR * Textauszug ndern
 MOVE.L D0,A0
 MOVEQ #3,D1
KOOLP:
 JSR READCHAR
 BEQ ERRO
 DBF D1,KOOLP
 MOVEQ #63,D1
KMODLP:
 JSR READCHAR
 BEQ ERRO
 CMP.B #'.',D0
 BEQ.S KMODXT
 MOVE.B D0,(A0)
KMODXT:
 ADDQ.L #1,A0
 DBF D1,KMODLP
 RTS

DISASSMOD:
 JSR READADR  * Disass. listing ndern
 BCLR #0,D0
 MOVE.L D0,A0
 MOVE.L D0,A2
 JSR READWORD
DISMODLP:
 MOVE.W D0,(A0)+    * alle Hexworte bernehmen
 JSR READCHAR
 BEQ.S DISMNEW
 CMP.B #32,D0
 BNE ERRO
 JSR READCHAR
 CMP.B #32,D0
 BEQ.S DISMNEW
 JSR READBACK
 JSR READWORD
 BRA.S DISMODLP
DISMNEW:
 MOVE.L A2,A0
 JSR DISASS   * nchste Listingzeile ausg.
 JSR CARRET
 JSR DISASS
 MOVEQ #10,D1
 MOVE.W CRSY,D2
 JSR RCRSET
 JMP NOPNTINP


OCCUPY:
 JSR READADR    * Speicherbereich mit Bytefolge ausfllen
 MOVE.L D0,A0
 JSR READADR
 MOVE.L D0,A1
 CMP.L A1,A0    * Eadr mu > Aadr
 BCC ERRO
 JSR READCHAR
 BNE.S OCDEF
 CLR.W D0       * Default Null
 BRA.S OPUBY
OCDEF:
 JSR READBACK
 JSR READBYTE
OPUBY:
 MOVE.W D0,-(SP)
 MOVEQ #2,D1
OBTLP:
 JSR READCHAR
 BEQ.S OBXT
 JSR READBACK
 JSR READBYTE
 MOVE.W D0,-(SP)
 ADD.W #2,D1
 BRA.S OBTLP
OBXT:
 MOVE.W D1,D2
OMEMLP:
 MOVE.W -2(A7,D2.W),D0
 SUB.W #2,D2
 BNE.S NNEWS
 MOVE.W D1,D2
NNEWS:
 MOVE.B D0,(A0)+
 CMP.L A0,A1
 BNE.S OMEMLP
 ADD.L D1,SP
 RTS


WRITEMEM:
 JSR READADR    * Speicherbereich verschieben
 MOVE.L D0,A0
 JSR READADR
 MOVE.L D0,A1
 CMP.L A1,A0
 BCC ERRO
 JSR READADR
 MOVE.L D0,A2
 CMP.L A2,A0
 BCC.S WOUTS   * A2 <= A0
 CMP.L A1,A2
 BCC.S WOUTS   * A2 => A1
 MOVE.L A1,D0
 SUB.L A0,D0
 ADD.L D0,A2
WRILP:
 MOVE.B -(A1),-(A2)
 CMP.L A0,A1
 BNE.S WRILP
 RTS
WOUTS:
 MOVE.B (A0)+,(A2)+
 CMP.L A0,A1
 BNE.S WOUTS
 RTS

COMPARE:
 JSR READADR    * Speicherber. vergl.
 MOVE.L D0,A0
 JSR READADR
 MOVE.L D0,A1
MCOMPLP:
 CMPM.B (A0)+,(A1)+  *<<<
 BEQ.S MCOMPLP
 SUBQ.L #1,A0
 MOVE.L A0,-(SP)
 JSR EINGPOS
 JSR RESTZLSH
 JSR SPACES
 MOVE.L (SP)+,D0
 JMP ADRHEX 


FINDBYTES:
 JSR MUSTREAD
 CMP.B #'"',D0  * in Disass.listing suchen ?
 BEQ DISFIND

 JSR READBACK
 JSR READADR  * Bytefolge im Ber. a0,a1 suchen
 MOVE.L D0,A0
 JSR READADR
 MOVE.L D0,A1
 CMP.L A1,A0
 BCC ERRO
 JSR READCHAR
 BEQ ERRO
 JSR READBACK
 CLR.L D1
GFBYLP:
 JSR READCHAR
 BEQ.S GFXT
 CMP.B #32,D0
 BEQ.S GFBYLP
 CMP.B #'"',D0
 BEQ.S FTEXT
 CMP.B #$2A,D0  * '*'= Joker
 BEQ.S FJOKER
 JSR READBACK
 JSR READBYTE   * Hexwert
FPUSHBY:
 MOVE.W D0,-(SP)
 ADDQ.W #2,D1
 BRA.S GFBYLP
FTEXT:
 JSR READCHAR
 BEQ.S GFXT
 CMP.B #$22,D0
 BEQ.S GFBYLP
 MOVE.W D0,-(SP)
 ADDQ.W #2,D1
 BRA.S FTEXT
FJOKER:
 MOVE.W #$8000,D0
 BRA.S FPUSHBY
GFXT:
 TST.W D1
 BEQ ERRO
 JSR CARRET
 CLR.L D3
 MOVE.W D1,D2
FINDLP:
 MOVE.W -2(A7,D2.W),D0   * Suchschleife
 BMI.S FJOK
 CMP.B (A0)+,D0
 BEQ.S FSTM
 TST.W D3
 BNE.S FNINIT
FWEITR:
 CMP.L A1,A0
 BCS.S FINDLP
FEND:
 ADD.L D1,SP
 RTS
FNINIT:
 SUB.L D3,A0
 MOVE.W D1,D2
 CLR.L D3
 BRA.S FWEITR
FJOK:
 ADDQ.L #1,A0
FSTM:
 ADDQ.W #1,D3
 SUBQ.W #2,D2
 BNE.S FINDLP

 MOVE.L A0,D0
 SUB.L D3,D0
 MOVE.W CRSX,D2    * max. 6 Zahlen/Zl.
 CMP.B #60,D2
 BNE.S FADR
 JSR LINEOUT
FADR:
 JSR SPACES
 JSR ADRHEX
 MOVE.L D0,A0
 ADDQ.L #1,A0
 JSR STOPTEST
 BEQ.S FEND
 CMP.B #32,D0
 BNE.S FANWT
 JSR CONIN
 CMP.B #$1B,D0
 BEQ.S FEND
FANWT:
 MOVE.W D1,D2
 CLR.L D3
 BRA.S FWEITR


DISFIND:
 LEA VRAM+2000,A0   * in Disass.listing suchen
 MOVE.L A0,A2
GETDFSTR:
 JSR READCHAR
 BEQ ERRO
 CMP.B #'"',D0
 BEQ.S DFSTRFU
 MOVE.B D0,(A0)+
 BRA.S GETDFSTR
DFSTRFU:
 CLR.B (A0)
 JSR READADR
 MOVE.L D0,A0
 LEA $FF8000,A1
 JSR READCHAR
 BEQ.S DFONEAD
 JSR READBACK
 JSR READADR
 MOVE.L D0,A1
DFONEAD:
 JSR CARRET
DISFNDLP:
 JSR DISASS
 LEA VRAM,A3
 MOVEQ #80,D0
 MULU CRSY,D0
 ADD.W D0,A3
 CLR.W D1
 MOVEQ #36,D2
DISSUCH:
 MOVE.B 0(A2,D1.W),D0
 BEQ.S DFOUND
 CMP.B 0(A3,D2.W),D0  * Text in VRAM suchen
 BEQ.S DF100
 CMP.B #'*',D0    * Joker
 BEQ.S DF100
 SUB.W D1,D2
 CLR.W D1
 CMP.W #75,D2
 BCC.S DFNOTF
 ADDQ.W #1,D2
 BRA.S DISSUCH
DF100:
 ADDQ.W #1,D1
 ADDQ.W #1,D2
 MOVE.B 0(A2,D1.W),D0
 BEQ.S DFOUND
 BRA.S DISSUCH
DFOUND:
 JSR LINEOUT
DFNOTF:
 JSR STOPTEST
 BEQ ILL
 CMP.L A1,A0
 BCS.S DISFNDLP
 RTS


* Trace-Funktionen

TRACER:
 JSR READCHAR
 BEQ ERRO
 JSR KLEINERBU
 CMP.B #'w',D0
 BEQ.S TRWALK
 CMP.B #'s',D0
 BEQ TSTOP
 CMP.B #'b',D0
 BEQ TBREAK
 CMP.B #'q',D0
 BEQ TQUICK
 CMP.B #'a',D0
 BEQ TRAMOUNT
 JMP ERRO


TRWALK:
 JSR READPC   * Einzelschrittmodus
 JSR SCRCLR

TWALKLP:
 JSR TRACEON
 JSR EXCVSET
 LEA TWENTRY,A0
 MOVE.L A0,$0024  * TRACE - Vektor
 JSR HOME
 JSR CRSON
 JSR REGISTOUT
 CLR.W D1
 MOVEQ #14,D2
 JSR RCRSET
 MOVEQ #'M',D0    * delete line
 JSR ESCOUT
 MOVE.L D2,D0
 JSR DELLINE
 MOVEQ #23,D2
 JSR RCRSET
 MOVE.L PCOUNTER,A0
 JSR DISASS
 LEA TWTX,A0
 JSR STROUT
TWTAST:
 MOVE #$2300,SR
 JSR CONIN
 CMP.B #$1B,D0
 BEQ.S TWEXT
 CMP.B #32,D0
 BEQ GOPC    * nchsten Opcode ausfhren
 JSR KLEINERBU
 CMP.B #'e',D0
 BEQ.S TWRTE
 CMP.B #'s',D0
 BEQ.S TWRTS
 CMP.B #'c',D0
 BNE.S TWTAST
 JSR SCRNEW
 BRA.S TWTAST
TWENTRY:
 JSR SAVREG
 JMP TWALKLP

TWEXT:
 JSR TRACEOFF
 JSR EXCVSET
 JSR ZEILANF
 JSR RESTZLSH
 JSR CRSUP
 JMP MAINLOOP

TWRTE:
 LEA PSTAT,A0      * EXCEPTIONroutine beenden
 BTST #5,(A0)
 BEQ.S TWTAST
 MOVE.L SUPVSTP,A2
 AND.W #$7FFF,(A2) * TB lschen!
 ADDQ.L #2,A2
 BRA.S TWSUPER

TWRTS:
 MOVE.L SUPVSTP,A2 * UPRO beenden
 LEA PSTAT,A0
 BTST #5,(A0)
 BNE.S TWSUPER * richtigen SP holen!!!
 MOVE USP,A2
TWSUPER:
 CLR.W D1
 MOVEQ #13,D2
 JSR RCRSET
 LEA ZWA,A0
 MOVE.L (A2),(A0) * RET.-Adr. merken
 LEA TWTRP,A0
 MOVE.L A0,(A2)
 ADDQ.L #2,A0
 MOVE.L A0,$0080
 BSR.S TRACEOFF
 JSR GOPC *
TWTRP: DC.W $4E40 * TRAP #0
TWRUECK:
 JSR SAVREG
 LEA PCOUNTER,A0
 MOVE.L ZWA,(A0)
 JMP TWALKLP

TRACEON:
 LEA PSTAT,A0
 OR.W #$8000,(A0) * Trace-Bit setzen
 RTS
TRACEOFF:
 LEA PSTAT,A0
 AND.W #$7FFF,(A0) *TB lschen
 RTS

TSTOP:
 JSR READADR     * TRACE-STOP
 LEA PCOUNTER,A0
 MOVE.L D0,(A0)
 LEA ZWA,A0
 JSR READADR
 MOVE.L D0,(A0)  * Halteadr. merken
 MOVE.L D0,A1
 LEA TQOP,A0
 MOVE.W (A1),(A0) * Opcode merken
 MOVE.W #$4E40,(A1) * TRAP #0
 LEA TSTOPENT,A0
 MOVE.L A0,$0080
 JSR CARRET
 JSR GOPC
TSTOPENT:
 JSR SAVREG
 JSR EXCVSET
 MOVE.L ZWA,A0
 MOVE.W TQOP,(A0)
 LEA PCOUNTER,A0
 SUBQ.L #2,(A0)

TREGSENT:
 MOVEQ #'T',D0   * blinkendes "T"
 JSR PRINT
 JSR CRSON
 JSR CRSLEFT
 MOVE.W #$2300,SR
 JSR CONIN
 JSR REGISTOUT
 JMP MAINLOOP

TBREAK:
 LEA TQADR,A0
 JSR READADR    * Haltepunkt
 MOVE.L D0,(A0)+
 JSR READWORD   * Anzahl Durchlufe
 TST.W D0
 BEQ ERRO
 MOVE.W D0,(A0)
 RTS

TQUICK:
 MOVE.W TQANZ,D0
 BEQ ERRO
 JSR READPC         * Schnellschrittmodus
 LEA TQOP,A0
 MOVE.L TQADR,A1
 MOVE.W (A1),(A0)   * Opcode merken
TQLP:
 JSR EXCVSET
 MOVE.L TQADR,A0
 MOVE.W #$4E40,(A0) * TRAP #0
 LEA TQENT,A0
 MOVE.L A0,$0080
 JSR GOPC
TQENT:
 JSR SAVREG
 JSR EXCVSET
 MOVE.L TQADR,A0
 MOVE.W TQOP,(A0)
 LEA PCOUNTER,A0
 SUBQ.L #2,(A0)
 LEA TQANZ,A0
 SUBQ.W #1,(A0)
 BEQ TWALKLP     * Anzahl Durchlufe erreicht
 JSR TRACEON
 LEA TQWEITR,A0
 MOVE.L A0,$0024
 JSR GOPC
TQWEITR:
 JSR SAVREG
 JSR TRACEOFF
 BRA.S TQLP

TRAMOUNT:
 JSR READADR    * Anzahl Befehle abarbeiten
 LEA PCOUNTER,A0
 MOVE.L D0,(A0)
 JSR READLONG
 TST.L D0
 BEQ ERRO
 LEA ZWA,A0
 MOVE.L D0,(A0)
 JSR TRACEON
 LEA TRAENT,A0
 MOVE.L A0,$024
 JSR CARRET
 JSR GOPC
TRAENT:
 MOVE.L A0,-(SP)
 LEA ZWA,A0
 SUBQ.L #1,(A0) * Zhler
 BEQ.S TRAOK
 MOVE.L (SP)+,A0
 RTE
TRAOK:
 MOVE.L (SP)+,A0
 JSR SAVREG
 JSR TRACEOFF
 JSR EXCVSET
 JMP TREGSENT

TQOP: DS.W 1
TQADR: DS.L 1
TQANZ: DS.W 1

TWTX: DC.B CR,'  ( )next,(esc)stop,(c)lear,rt(s),rt(e) ?',0
 DC.W 0




* Arithmetik

DEZUM:
 JSR READDEZ * Dez. => Hex.
 JSR GLZCH
 JSR DOLLAR
 JMP LONGHEX

HEXUM:
 JSR READLONG  * hex. (=> bin.) => dez.
 MOVE.L D0,-(SP)
 JSR EINGPOS
 JSR RESTZLSH
 CMP.L #$100,(A7) * Bytegre
 BCC.S WDZAU
 LEA GLZTXT,A0
 JSR STROUT
 MOVEQ #'%',D0
 JSR PRINT
 MOVE.L (A7),D0
 JSR BYTEBIN
WDZAU:
 LEA GLZTXT,A0
 JSR STROUT
 MOVEQ #'#',D0
 JSR PRINT
 MOVE.L (SP)+,D0
 JMP DEZOUT

BINUM:
 JSR READBINBYT * bin. => hex. => dez.
 MOVE.L D0,-(SP)
 JSR GLZCH
 JSR DOLLAR
 JSR BYTEHEX
 BRA.S WDZAU

RECHNUNG:
* einfache 16/32 Bit Berechnungen
 JSR MUSTREAD
 CMP.B #'+',D0
 BEQ.S RPLUS
 CMP.B #'-',D0
 BEQ RMINUS
 CMP.B #'*',D0
 BEQ RMULT
 CMP.B #'/',D0
 BEQ RDIV
 CMP.B #'&',D0
 BEQ RUND
 CMP.B #'',D0
 BEQ RODER
 CMP.B #'!',D0
 BEQ REXOR
 JMP ERRO

RPLUS:
 JSR READLONG
 MOVE.L D0,D1
 JSR READLONG
 ADD.L D1,D0
 BSR.S GLZCH
 JMP LONGHEX

GLZCH:
 MOVE.L D0,-(SP)
 BSR.S EINGPOS
 JSR RESTZLSH
 LEA GLZTXT,A0
 JSR STROUT
 MOVE.L (SP)+,D0
 RTS
GLZTXT:
 DC.B ' = ',0
DOLLAR:
 MOVE.L D0,-(SP)
 MOVEQ #'$',D0
 JSR PRINT
 MOVE.L (SP)+,D0
 RTS

ZENDPOS:
 MOVEM.L D1-D2,-(SP) * C. auf Ende der Zeile
 MOVE.W EINGLAENG,D1
 MOVE.W CRSY,D2
 JSR RCRSET
 MOVEM.L (SP)+,D1-D2
 RTS

EINGPOS:
 MOVEM.L D1-D2,-(SP) * C. auf 1. Zch. nach gelesenem
 MOVE.W EINGPTR,D1
 MOVE.W CRSY,D2
 JSR RCRSET
 MOVEM.L (SP)+,D1-D2
 RTS

RMINUS:
 JSR READLONG
 MOVE.L D0,D1
 JSR READLONG
 SUB.L D0,D1
 MOVE.L D1,D0
 BSR.S GLZCH
 JMP LONGHEX

RMULT:
 JSR READWORD
 MOVE.W D0,D1
 JSR READWORD
 MULU D1,D0
 BSR.S GLZCH
 JMP LONGHEX
 
RDIV:
 JSR READLONG
 MOVE.L D0,D1
 JSR READWORD
 TST.W D0
 BEQ ERRO
 DIVU D0,D1
 BVS ERRO
 SWAP D1
 MOVE.L D1,-(SP)
 JSR GLZCH
 MOVE.W (SP)+,D0
 JSR WORDHEX
 MOVEQ #32,D0
 JSR PRINT
 JSR PRINT
 MOVEQ #'\',D0
 JSR PRINT
 MOVE.W (SP)+,D0
 JMP WORDHEX  * Div. rest ausg.

RUND:
 JSR READLONG
 MOVE.L D0,D1
 JSR READLONG
 AND.L D1,D0
 JSR GLZCH
 JMP LONGHEX

RODER:
 JSR READLONG
 MOVE.L D0,D1
 JSR READLONG
 OR.L D1,D0
 JSR GLZCH
 JMP LONGHEX

REXOR:
 JSR READLONG
 MOVE.L D0,D1
 JSR READLONG
 EOR.L D1,D0
 JSR GLZCH
 JMP LONGHEX



* Dateibehandlung

FLOAD:
 JSR GETFLNAM   * a1= Filename,a2= DTA
 JSR READADR
 MOVE.L D0,A3   * Ladeadresse
 CLR.W -(SP)
 PEA (A1)
 MOVE.W #$4E,-(SP)  * SFIRST
 TRAP #1
 ADDQ.L #8,SP
 TST.W D0
 BNE DISKERR

 LEA LOADINFO,A0
 JSR STROUT
 JSR FILENOUT
 MOVE.L 26(A2),D2   * Anzahl Bytes
 MOVE.L D2,D3
 ADD.L A3,D3        * => Endadr.

 CLR.W -(SP)        * nur lesen
 PEA 30(A2)         * filename adr.
 MOVE.W #$3D,-(SP)  * OPEN
 TRAP #1
 ADDQ.L #8,SP
 TST.W D0
 BMI DISKERR
 MOVE.W D0,D1       * HANDLE-Nr.

 PEA (A3)           * BUFFER
 MOVE.L D2,-(SP)    * AMOUNT
 MOVE.W D1,-(SP)    * HANDLE
 MOVE.W #$3F,-(SP)  * READ
 TRAP #1       
 ADD.W #12,SP
 TST.L D0
 BMI DISKERR
 JSR CLOSED1
 BMI DISKERR
 LEA FEADRTX,A0
 JSR STROUT
 MOVE.L D3,D0
 JMP ADRHEX


FSAVE:
 JSR GETFLNAM    * Speicherber. abspeichern
 JSR READADR
 MOVE.L D0,A3
 JSR READADR
 SUB.L A3,D0
 BEQ ERRO
 BCS ERRO
 MOVE.L D0,D2    * Anzahl Bytes

 CLR.W -(SP)     * Leseversuch
 PEA (A1)
 MOVE.W #$3D,-(SP)
 TRAP #1         * OPEN
 ADDQ.L #8,SP
 CMP.W #-33,D0   * 'FILENOTFOUND'
 BEQ.S NRMSAVE
 TST.W D0
 BMI DISKERR
 MOVE.W D0,D1    * File schon vorhanden
 JSR CLOSED1
 BMI DISKERR
 JSR NACHFRAG    * Frage, ob berschrieben werden soll
 BNE ILL

NRMSAVE:
 CLR.W -(SP)
 PEA (A1)
 MOVE.W #$3C,-(SP)
 TRAP #1         * CREATE FILE
 ADDQ.L #8,SP
 TST.W D0
 BMI DISKERR
 MOVE.W D0,D1    * HANDLE

 PEA (A3)
 MOVE.L D2,-(SP)
 MOVE.W D1,-(SP)
 MOVE.W #$40,-(SP) * WRITE
 TRAP #1
 ADD.W #12,SP
 TST.L D0
 BMI DISKERR
 JSR CLOSED1
 BMI DISKERR
 RTS


DIRECT:
 JSR READCHAR      * @ -Befehl
 BEQ.S CATDEFAU
 CMP.B #32,D0
 BEQ.S CATOUT
 CMP.B #'\',D0
 BEQ.S NEWPATH
 JSR KLEINERBU
 CMP.B #'a',D0
 BCS ERRO
 CMP.B #'e'+1,D0
 BCS.S SETDRIVE
 JMP ERRO

NEWPATH:
 JSR READBACK
 JSR GETSTR
 PEA (A1)
 MOVE.W #$3B,-(SP) * CHDIR
 TRAP #1
 ADDQ.L #6,SP
 TST.W D0
 BMI DISKERR
 RTS

SETDRIVE:
 SUB.B #'a',D0
 AND.W #$0F,D0
 MOVE.W D0,-(SP)
 MOVE.W #$0E,-(SP)
 TRAP #1
 ADDQ.L #4,SP
 TST.W D0
 BMI DISKERR
 RTS

CATDEFAU:
 LEA SHORTFLN,A1
 BRA.S CATSUCH
SHORTFLN: DC.B '*.*',0

CATOUT:
 JSR GETSTR
CATSUCH:
 MOVE.W #$10,-(SP)
 PEA (A1)
 MOVE.W #$4E,-(SP) * SFIRST
 TRAP #1
 ADDQ.L #8,SP
 TST.W D0
 BMI DISKERR
 JSR CARRET
CATLP:
 MOVEQ #4,D0
 JSR SPACETAB
 JSR FILENOUT
 MOVE.L D0,A1      * DTA
 MOVEQ #19,D0
 JSR SPACETAB
 MOVE.L 26(A1),D0  * Lnge
 JSR DEZOUT
 MOVEQ #29,D0
 JSR SPACETAB
 MOVE.B 21(A1),D0  * Attribut
 JSR BYTEHEX
 JSR LINEOUT
 JSR STOPTEST
 BEQ ILL
 MOVE.W #$4F,-(SP) * SNEXT
 TRAP #1
 ADDQ.L #2,SP
 CMP.W #-49,D0
 BEQ.S CATEND
 TST.W D0
 BMI DISKERR
 BRA.S CATLP
CATEND:
 LEA VRAM+2000,A1
 CLR.W -(SP)
 PEA (A1)
 MOVE.W #$36,-(SP) * GET DISK FREE SPACE
 TRAP #1
 ADDQ.L #8,SP
 MOVE.L (A1),D0
 JSR SPACES
 JSR DEZOUT
 LEA DFREETX,A0
 JSR STROUT
 JMP PRINTLINE
DFREETX: DC.B ' alloc',$27,'s free.',0
 DC.W 0

GETSTR:
 LEA VRAM+2000,A0
 MOVE.L A0,A1
GETSTRLP:
 JSR READCHAR
 MOVE.B D0,(A0)+
 TST.B D0
 BNE GETSTRLP
 RTS



GETFLNAM:
 JSR READCHAR   * Dateinamen und Parameter holen
 CMP.B #'"',D0  * Space oder " als Trennzch.
 BEQ GFLNWT
 CMP.B #32,D0
 BNE ERRO
GFLNWT:
 JSR READCHAR
 BEQ ERRO
 JSR READBACK
 LEA VRAM+2000,A0
 MOVE.L A0,A1
FNAMBYT:
 JSR READCHAR
 BEQ ERRO
 CMP.B #'\',D0   * verboten!
 BEQ ERRO
 CMP.B #',',D0
 BEQ.S FNAMEND
 CMP.B #'"',D0
 BEQ.S FNAMEND
 MOVE.B D0,(A0)+
 BRA.S FNAMBYT
FNAMEND:
 CLR.B (A0)
 MOVE.W #$2F,-(SP) * GET DTA Adresse nach d0,A2
 TRAP #1
 ADDQ.L #2,SP
 MOVE.L D0,A2
 RTS

FILENOUT:
 MOVE.W #$2F,-(SP) * Filenamen aus DTA ausg.
 TRAP #1
 ADDQ.L #2,SP
 MOVE.L D0,A0
 ADD.W #30,A0
 JMP STROUT

CLOSED1:
 MOVE.W D1,-(SP)    * Handlenr. in d1
 MOVE.W #$3E,-(SP)  * CLOSE
 TRAP #1
 ADDQ.L #4,SP
 TST.W D0
 RTS

DISKERR:
 LEA DISKETX,A0  * Disketten-Fehlernummer in D0
 JSR STROUT
 NEG.L D0
 JMP DEZOUT
DISKETX: DC.B CR,'!disk error: -',0

LOADINFO: DC.B CR,'loading: ',0
FEADRTX:  DC.B '   end adress: $',0
 DC.W 0



 INCLUDE DISKM.ASM

